<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>multialignfasta.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>multialignfasta.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Multiple alignment whith Clustal.
These functions are used in  <a href="views.html">views.py</a> in the function align_multiple_sequence().</p>
<p>Currently we support the following 16 functions:</p>
<ol>
<li><strong>Generate_aln_dnd</strong> - Generate files (aln, dnd) of alignment</li>
<li><strong>Get_names_aln_dnd</strong> - Give paths of the files aln and dnd</li>
<li><strong>Get_title_file</strong> - Give the names of the files</li>
<li><strong>Get_name_title_file</strong> - Gives the name of a file, without the extension .dnd</li>
<li><strong>Random_string</strong> - Generate random names unique</li>
<li><strong>Write_file_sequences</strong> - Create a file when the user enters sequences</li>
<li><strong>Delete_dir</strong> - Delete all files of directory ( used in the function delete_all_urls())</li>
<li><strong>Validate_file</strong> - Validate sequences</li>
<li><strong>Is_fasta</strong> - Format .fasta</li>
<li><strong>Is_fasta_extension</strong> - Check if the file extension is .fasta, .fa, .fna, .ffn, .faa, .frn</li>
<li><strong>Empty_sequences</strong> - Check if sequences are empty</li>
<li><strong>Len_seq_ids</strong> - Check if the sequences are correct</li>
<li><strong>Names_empty</strong> - Value empty in a list</li>
<li><strong>is_blanck</strong> - String empty</li>
<li><strong>Num_seq</strong> - Return the number of sequences</li>
<li><strong>Unique_values</strong> - The content after the character  &gt; must be unique</li>
</ol>
<p>References:</p>
<p>Multiple sequence alignment :
https://en.wikipedia.org/wiki/Multiple_sequence_alignment</p>
<p>The effect of the guide tree on multiple sequence alignments and subsequent phylogenetic analyses :
https://www.ncbi.nlm.nih.gov/pubmed/18229674</p>
<p>Biopython :
http://biopython.org/DIST/docs/tutorial/Tutorial.html#htoc82</p>
<p>FASTA file :
https://en.wikipedia.org/wiki/FASTA_format</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">shutil</span>
<span class="kn">import</span> <span class="nn">random</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">from</span> <span class="nn">Bio</span> <span class="kn">import</span> <span class="n">SeqIO</span>
<span class="kn">from</span> <span class="nn">Bio.Align.Applications</span> <span class="kn">import</span> <span class="n">ClustalwCommandline</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <p>defined in  <a href="models.html">models.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">proteins.models</span> <span class="kn">import</span> <span class="n">Url</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <h3><span id="generate_aln_dnd" href="generate_aln_dnd"> Generate_aln_dnd </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">generate_aln_dnd</span><span class="p">(</span><span class="n">file_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">user</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <p>Generate files  .aln (multiple alignment) and  .dnd (guide tree).
Call functions : get_names_aln_dnd () ,  get_title_file () and get_name_title_file()</p>
<p>Arguments:</p>
<p>file_name {str} &ndash; path file</p>
<p>user {user} &ndash; user</p>
<p>Returns:</p>
<p>[tuple] &ndash; Returns a boolean if there has been an error and returns
  the name of the file that was created</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">result</span> <span class="o">=</span> <span class="kc">False</span>
    <span class="n">clustalw_exe</span> <span class="o">=</span> <span class="sa">r</span><span class="s2">&quot;/usr/bin/clustalw&quot;</span>
    <span class="n">clustalw_cline</span> <span class="o">=</span> <span class="n">ClustalwCommandline</span><span class="p">(</span><span class="n">clustalw_exe</span><span class="p">,</span> <span class="n">infile</span><span class="o">=</span><span class="n">file_name</span><span class="p">)</span>
    <span class="k">assert</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">isfile</span><span class="p">(</span><span class="n">clustalw_exe</span><span class="p">),</span> <span class="s2">&quot;Clustal W executable missing&quot;</span>
    <span class="n">stdout</span><span class="p">,</span> <span class="n">stderr</span> <span class="o">=</span> <span class="n">clustalw_cline</span><span class="p">()</span>
    <span class="n">thistuple</span> <span class="o">=</span> <span class="n">clustalw_cline</span><span class="p">()</span>
    <span class="n">tuples0</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">thistuple</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">tuple_names</span> <span class="o">=</span> <span class="n">get_names_aln_dnd</span><span class="p">(</span><span class="n">tuples0</span><span class="p">)</span>

    <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="n">get_title_file</span><span class="p">(</span>
        <span class="n">tuple_names</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="n">types</span><span class="o">=</span><span class="s1">&#39;Guide Tree&#39;</span><span class="p">,</span> <span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">tuple_names</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">sequences</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>

    <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="n">get_title_file</span><span class="p">(</span>
        <span class="n">tuple_names</span><span class="p">[</span><span class="mi">1</span><span class="p">]),</span> <span class="n">types</span><span class="o">=</span><span class="s1">&#39;Alignments&#39;</span><span class="p">,</span> <span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">tuple_names</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">sequences</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>

    <span class="n">name_title</span> <span class="o">=</span> <span class="n">get_name_title_file</span><span class="p">(</span><span class="n">get_title_file</span><span class="p">(</span><span class="n">tuple_names</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
    <span class="k">if</span> <span class="n">stderr</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="k">return</span> <span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">name_title</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <h3><span id="get_names_aln_dnd" href="get_names_aln_dnd"> Get_names_aln_dnd </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_names_aln_dnd</span><span class="p">(</span><span class="n">cadena</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <p>Give absolute paths of the files aln and dnd.</p>
<p>Arguments:</p>
<p>cadena {str} &ndash; paths of the files</p>
<p>Returns:</p>
<p>[tuple] &ndash; names of the files</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">listresult</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">name1_search_tuple</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span>
        <span class="sa">r</span><span class="s1">&#39;file\s+created:\s+(\[.+\.dnd\])&#39;</span><span class="p">,</span> <span class="n">cadena</span><span class="p">)</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">listresult</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">name1_search_tuple</span><span class="p">)</span>
    <span class="n">name2_search_tuple</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span>
        <span class="sa">r</span><span class="s1">&#39;CLUSTAL-Alignment\s+file\s+created\s+(\[.+\.aln\])&#39;</span><span class="p">,</span> <span class="n">cadena</span><span class="p">)</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">listresult</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">name2_search_tuple</span><span class="p">)</span>

    <span class="n">list_names_split</span> <span class="o">=</span> <span class="p">[</span><span class="n">n</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;[&#39;</span><span class="p">)</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">listresult</span><span class="p">]</span>
    <span class="n">l_name1</span> <span class="o">=</span> <span class="n">list_names_split</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;]&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">l_name2</span> <span class="o">=</span> <span class="n">list_names_split</span><span class="p">[</span><span class="mi">1</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;]&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
    <span class="k">return</span> <span class="p">(</span><span class="n">l_name1</span><span class="p">,</span> <span class="n">l_name2</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <h3><span id="get_title_file" href="get_title_file"> Get_title_file </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_title_file</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>Give the names of the files aln and dnd.</p>
<p>Arguments:</p>
<p>path {str} &ndash; path of file</p>
<p>Returns:</p>
<p>[str] &ndash; name of the file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">pattern_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;media\/.+\/(.+)&#39;</span><span class="p">)</span>
    <span class="n">prog_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern_name</span><span class="p">)</span>
    <span class="n">result_name</span> <span class="o">=</span> <span class="n">prog_name</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">path</span><span class="p">)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">result_name</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">name</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      <h3><span id="get_name_title_file" href="get_name_title_file"> Get_name_title_file </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_name_title_file</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-9'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-9'>#</a>
      </div>
      <p>Gives the name of a file, without the extension .dnd</p>
<p>Arguments:</p>
<p>path {str} &ndash; name file with extension</p>
<p>Returns:</p>
<p>[str] &ndash;  file name without extension</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">pattern_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;(.+)\.dnd&#39;</span><span class="p">)</span>
    <span class="n">prog_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern_name</span><span class="p">)</span>
    <span class="n">result_name</span> <span class="o">=</span> <span class="n">prog_name</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">path</span><span class="p">)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">result_name</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">name</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-10'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-10'>#</a>
      </div>
      <h3><span id="random_string" href="random_string"> Random_string </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">random_string</span><span class="p">(</span><span class="n">string_length</span><span class="o">=</span><span class="mi">8</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-11'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-11'>#</a>
      </div>
      <p>Generate random names unique</p>
<p>Keyword Arguments:</p>
<p>string_length {int} &ndash; name (default: {8})</p>
<p>Returns:</p>
<p>[str] &ndash; random name</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">letters</span> <span class="o">=</span> <span class="n">string</span><span class="o">.</span><span class="n">ascii_lowercase</span>
    <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="n">letters</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">string_length</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-12'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-12'>#</a>
      </div>
      <h3><span id="write_file_sequences" href="write_file_sequences"> Write_file_sequences </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">write_file_sequences</span><span class="p">(</span><span class="n">sequences</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">user</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-13'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-13'>#</a>
      </div>
      <p>Create a file when the user enters sequences.
Call functions :  random_string ()</p>
<p>Arguments:</p>
<p>sequences {str} &ndash; sequences</p>
<p>user {[type]} &ndash; user</p>
<p>Returns:</p>
<p>[str] &ndash; new path file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="s1">&#39;media/user_&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">user</span><span class="o">.</span><span class="n">id</span><span class="p">),</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">file_suffix</span> <span class="o">=</span> <span class="n">random_string</span><span class="p">(</span><span class="mi">15</span><span class="p">)</span>
    <span class="n">name_file</span> <span class="o">=</span> <span class="s1">&#39;seq_&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">user</span><span class="o">.</span><span class="n">id</span><span class="p">)</span> <span class="o">+</span> <span class="n">file_suffix</span> <span class="o">+</span> <span class="s1">&#39;.fasta&#39;</span>
    <span class="n">path_file</span> <span class="o">=</span> <span class="s1">&#39;media/user_&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">user</span><span class="o">.</span><span class="n">id</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;/&#39;</span> <span class="o">+</span> <span class="n">name_file</span>

    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path_file</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">fil</span><span class="p">:</span>
        <span class="n">fil</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">sequences</span><span class="p">)</span>

    <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="n">name_file</span><span class="p">,</span> <span class="n">types</span><span class="o">=</span><span class="s1">&#39;MultiFasta&#39;</span><span class="p">,</span>
                       <span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">path_file</span><span class="p">,</span> <span class="n">sequences</span><span class="o">=</span><span class="n">sequences</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">path_file</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-14'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-14'>#</a>
      </div>
      <h3><span id="delete_dir" href="delete_dir"> Delete_dir </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">delete_dir</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-15'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-15'>#</a>
      </div>
      <p>Delete all files of directory</p>
<p>Arguments:</p>
<p>path {str} &ndash; path file</p>
<p>Returns:</p>
<p>[] &ndash; delete file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">dir_path</span> <span class="o">=</span> <span class="n">path</span>

    <span class="k">try</span><span class="p">:</span>
        <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">dir_path</span><span class="p">)</span>
        <span class="k">return</span> <span class="s2">&quot;&quot;</span>
    <span class="k">except</span> <span class="ne">OSError</span> <span class="k">as</span> <span class="n">error</span><span class="p">:</span>
        <span class="k">return</span> <span class="s2">&quot;Error: </span><span class="si">%s</span><span class="s2"> : </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">dir_path</span><span class="p">,</span> <span class="n">error</span><span class="o">.</span><span class="n">strerror</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-16'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-16'>#</a>
      </div>
      <h3><span id="validate_file" href="validate_file"> Validate_file </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">validate_file</span><span class="p">(</span><span class="n">filename</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-17'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-17'>#</a>
      </div>
      <p>Validate if file have 2 sequences minim (&gt;) and are unique names and is format .fasta</p>
<p>Call functions : is_fasta(), num_seq ()</p>
<p>Arguments:</p>
<p>filename {str} &ndash; path file</p>
<p>Returns:</p>
<p>[boolean] &ndash; validation</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">is_fasta</span><span class="p">(</span><span class="n">filename</span><span class="p">)</span> <span class="o">==</span> <span class="kc">True</span> <span class="ow">and</span> <span class="n">num_seq</span><span class="p">(</span><span class="n">filename</span><span class="p">)</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">True</span>
    <span class="k">return</span> <span class="kc">False</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-18'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-18'>#</a>
      </div>
      <h3><span id="is_fasta" href="is_fasta"> Is_fasta </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">is_fasta</span><span class="p">(</span><span class="n">filename</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-19'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-19'>#</a>
      </div>
      <p>Format .fasta</p>
<p>Arguments:</p>
<p>filename {str} &ndash; path file</p>
<p>Returns:</p>
<p>[boolean] &ndash; fasta</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">handle</span><span class="p">:</span>
        <span class="n">fasta</span> <span class="o">=</span> <span class="n">SeqIO</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">handle</span><span class="p">,</span> <span class="s2">&quot;fasta&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="nb">any</span><span class="p">(</span><span class="n">fasta</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-20'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-20'>#</a>
      </div>
      <h3><span id="is_fasta_extension" href="is_fasta_extension"> Is_fasta_extension </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">is_fasta_extension</span><span class="p">(</span><span class="n">name_file</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-21'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-21'>#</a>
      </div>
      <p>Check if the file extension is .fasta, .fa, .fna, .ffn, .faa, .frn</p>
<p>Arguments:</p>
<p>name_file {str} &ndash; name of file</p>
<p>Returns:</p>
<p>[boolean] &ndash; valid</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">extension</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;fasta&#39;</span><span class="p">,</span> <span class="s1">&#39;fa&#39;</span><span class="p">,</span> <span class="s1">&#39;fna&#39;</span><span class="p">,</span> <span class="s1">&#39;ffn&#39;</span><span class="p">,</span> <span class="s1">&#39;faa&#39;</span><span class="p">,</span> <span class="s1">&#39;frn&#39;</span><span class="p">]</span>
    <span class="n">valid</span> <span class="o">=</span> <span class="kc">False</span>

    <span class="k">for</span> <span class="n">ext</span> <span class="ow">in</span> <span class="n">extension</span><span class="p">:</span>
        <span class="n">pattern_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;.+(\.&#39;</span><span class="o">+</span><span class="n">ext</span><span class="o">+</span><span class="s1">&#39;)$&#39;</span><span class="p">)</span>
        <span class="n">prog_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern_name</span><span class="p">)</span>
        <span class="n">result_name</span> <span class="o">=</span> <span class="n">prog_name</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">name_file</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">result_name</span> <span class="o">!=</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">valid</span> <span class="o">=</span> <span class="kc">True</span>
            <span class="k">return</span> <span class="n">valid</span>
    <span class="k">return</span> <span class="n">valid</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-22'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-22'>#</a>
      </div>
      <h3><span id="empty_sequences" href="empty_sequences"> Empty_sequences </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">empty_sequences</span><span class="p">(</span><span class="n">filename</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-23'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-23'>#</a>
      </div>
      <p>Check if sequences are empty</p>
<p>Call functions : len_seq_ids()</p>
<p>Arguments:</p>
<p>filename {str} &ndash; path file</p>
<p>Returns:</p>
<p>[boolean] &ndash; check sequences</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">fil</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span>
    <span class="n">txt</span> <span class="o">=</span> <span class="n">fil</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>

    <span class="n">result</span> <span class="o">=</span> <span class="n">len_seq_ids</span><span class="p">(</span><span class="n">txt</span><span class="p">)</span>

    <span class="n">fil</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>

    <span class="k">return</span> <span class="n">result</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-24'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-24'>#</a>
      </div>
      <h3><span id="len_seq_ids" href="len_seq_ids"> Len_seq_ids </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">len_seq_ids</span><span class="p">(</span><span class="n">txt</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-25'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-25'>#</a>
      </div>
      <p>Check if the number of times the character &gt; is equal to the number of
sequences (the text between two characters &gt;)</p>
<p>Call functions: names_empty()</p>
<p>Arguments:</p>
<p>txt {str} &ndash; text</p>
<p>Returns:</p>
<p>[boolean] &ndash; check</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">list_seq2</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_seq3</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_ids</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_ids</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="s1">&#39;&gt;(.*)</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">txt</span><span class="p">)</span>

    <span class="n">regex</span> <span class="o">=</span> <span class="sa">r</span><span class="s1">&#39;^&gt;(.*)[^&gt;]&#39;</span>
    <span class="n">pat</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">regex</span><span class="p">,</span> <span class="n">re</span><span class="o">.</span><span class="n">MULTILINE</span><span class="p">)</span>
    <span class="n">txt_sub</span> <span class="o">=</span> <span class="n">pat</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="s2">&quot;*&quot;</span><span class="p">,</span> <span class="n">txt</span><span class="p">)</span>
    <span class="n">list_txt_split</span> <span class="o">=</span> <span class="n">txt_sub</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;*&quot;</span><span class="p">)</span>

    <span class="n">lenght</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_txt_split</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">lenght</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">list_txt_split</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">!=</span> <span class="s1">&#39;&#39;</span><span class="p">:</span>
            <span class="n">list_seq2</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">list_txt_split</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">))</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">list_seq2</span><span class="p">)):</span>
        <span class="k">if</span> <span class="n">list_seq2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">!=</span> <span class="s1">&#39;&#39;</span><span class="p">:</span>
            <span class="n">list_seq3</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">list_seq2</span><span class="p">[</span><span class="n">i</span><span class="p">])</span>

    <span class="n">check_names</span> <span class="o">=</span> <span class="n">names_empty</span><span class="p">(</span><span class="n">list_ids</span><span class="p">)</span>

    <span class="n">check_list</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">list_seq3</span><span class="p">)</span>
    <span class="n">check_s2</span> <span class="o">=</span> <span class="n">check_list</span><span class="o">.</span><span class="n">isalpha</span><span class="p">()</span>

    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_ids</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_seq3</span><span class="p">)</span> <span class="ow">and</span> <span class="n">check_s2</span> <span class="o">==</span> <span class="kc">True</span> <span class="ow">and</span> <span class="n">check_names</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">True</span>
    <span class="k">return</span> <span class="kc">False</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-26'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-26'>#</a>
      </div>
      <h3><span id="names_empty" href="names_empty"> Names_empty </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">names_empty</span><span class="p">(</span><span class="n">list_ids</span><span class="p">:</span> <span class="nb">list</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-27'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-27'>#</a>
      </div>
      <p>Value empty in a list</p>
<p>Call functions: is_blanck()</p>
<p>Arguments:</p>
<p>list_ids {list} &ndash; id list</p>
<p>Returns:</p>
<p>[boolean] &ndash; flat</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">flat</span> <span class="o">=</span> <span class="kc">False</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">list_ids</span><span class="p">)):</span>
        <span class="k">if</span> <span class="n">is_blanck</span><span class="p">(</span><span class="n">list_ids</span><span class="p">[</span><span class="n">i</span><span class="p">])</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
            <span class="n">flat</span> <span class="o">=</span> <span class="kc">True</span>
    <span class="k">return</span> <span class="n">flat</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-28'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-28'>#</a>
      </div>
      <h3><span id="is_blanck" href="is_blanck"> Is_blanck </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">is_blanck</span><span class="p">(</span><span class="n">my_str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-29'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-29'>#</a>
      </div>
      <p>String empty</p>
<p>Arguments:</p>
<p>my_str {str} &ndash; string</p>
<p>Returns:</p>
<p>[boolean] &ndash; if is blank</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">my_str</span> <span class="ow">and</span> <span class="n">my_str</span><span class="o">.</span><span class="n">strip</span><span class="p">():</span>
        <span class="k">return</span> <span class="kc">False</span>
    <span class="k">return</span> <span class="kc">True</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-30'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-30'>#</a>
      </div>
      <h3><span id="num_seq" href="num_seq"> Num_seq </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">num_seq</span><span class="p">(</span><span class="n">filename</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-31'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-31'>#</a>
      </div>
      <p>The number of sequences in the file is given by the number
of times the character appears &gt;</p>
<p>Call functions : unique_values ()</p>
<p>Arguments:</p>
<p>filename {str} &ndash; path file</p>
<p>Returns:</p>
<p>[boolean] &ndash; valid</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">valid</span> <span class="o">=</span> <span class="kc">False</span>
    <span class="n">numseq</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">list_names_seq</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">):</span>
        <span class="n">line</span> <span class="o">=</span> <span class="n">line</span><span class="o">.</span><span class="n">rstrip</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="s2">&quot;^&gt;&quot;</span><span class="p">,</span> <span class="n">line</span><span class="p">):</span>
            <span class="n">numseq</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="n">list_names_seq</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">unique_values</span><span class="p">(</span><span class="n">list_names_seq</span><span class="p">)</span> <span class="o">==</span> <span class="kc">True</span> <span class="ow">and</span> <span class="n">numseq</span> <span class="o">&gt;=</span> <span class="mi">2</span><span class="p">:</span>
        <span class="n">valid</span> <span class="o">=</span> <span class="kc">True</span>

    <span class="k">return</span> <span class="n">valid</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-32'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-32'>#</a>
      </div>
      <h3><span id="unique_values" href="unique_values"> Unique_values </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">unique_values</span><span class="p">(</span><span class="n">listg</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-33'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-33'>#</a>
      </div>
      <p>The content after the character  &gt; must be unique</p>
<p>Arguments:</p>
<p>listg {list} &ndash; list of sequence names</p>
<p>Returns:</p>
<p>[boolean] &ndash; check</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">seti</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">listg</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">seti</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">False</span>
        <span class="n">seti</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
    <span class="k">return</span> <span class="kc">True</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
